commit 4dc27c18044fb5a807ea06bdf83c477745de33c6
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Thu Jul 25 16:00:14 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/dbupgrade/show_partlist.html

diff --git a/templates/webpages/dbupgrade/show_partlist.html b/templates/webpages/dbupgrade/show_partlist.html
index 7b6a6a3b0..919443f11 100644
--- a/templates/webpages/dbupgrade/show_partlist.html
+++ b/templates/webpages/dbupgrade/show_partlist.html
@@ -5,34 +5,30 @@
 <h1>[% 'Show parts' | $T8 %]</h1>
 
 <form method="post" action="controller.pl">
-[% L.hidden_tag("action", "LoginScreen/login") %]
-[% L.hidden_tag("upgrade_action", "filter_parts") %]
-[% L.hidden_tag("no_layout", 1) %]
+  [% L.hidden_tag("action", "LoginScreen/login") %]
+  [% L.hidden_tag("upgrade_action", "filter_parts") %]
+  [% L.hidden_tag("no_layout", 1) %]
 
-<table>
+<table class="tbl-horizontal">
   <tbody>
     <tr>
-      <th align="right">[% 'Partnumber' | $T8 %]</th>
+      <th>[% 'Partnumber' | $T8 %]</th>
       <td>[% L.input_tag("filter_partnumber", filter_partnumber, size=20) %]</td>
     </tr>
-
     <tr>
-      <th align="right">[% 'Description' | $T8 %]</th>
+      <th>[% 'Description' | $T8 %]</th>
       <td>[% L.input_tag("filter_description", filter_description, size=20) %]</td>
     </tr>
-
     <tr>
-      <th align="right">[% 'Notes' | $T8 %]</th>
+      <th>[% 'Notes' | $T8 %]</th>
       <td>[% L.input_tag("filter_notes", filter_notes, size=20) %]</td>
     </tr>
-
     <tr>
-      <th align="right">[% 'EAN' | $T8 %]</th>
+      <th>[% 'EAN' | $T8 %]</th>
       <td>[% L.input_tag("filter_ean", filter_ean, size=20) %]</td>
     </tr>
-
     <tr>
-      <th align="right">[% 'Service, assembly or part' | $T8 %]</th>
+      <th>[% 'Service, assembly or part' | $T8 %]</th>
       <td>
         <select name="filter_type">
           <option value=""></option>
@@ -42,9 +38,8 @@
         </select>
       </td>
     </tr>
-
     <tr>
-      <th align="right">[% 'Valid/Obsolete' | $T8 %]</th>
+      <th>[% 'Valid/Obsolete' | $T8 %]</th>
       <td>
         <select name="filter_obsolete">
           <option value=""></option>
@@ -58,30 +53,36 @@
 
 <input type="submit" value="[% 'Filter parts' | $T8 %]" onclick="submit()">
 
-<table>
+<table class="tbl-list">
+<thead>
   <tr>
-    <th class="listheading">[% 'Partnumber' | $T8 %]</th>
-    <th class="listheading">[% 'Description' | $T8 %]</th>
-    <th class="listheading">[% 'Unit' | $T8 %]</th>
-    <th class="listheading">[% 'Notes' | $T8 %]</th>
-    <th class="listheading">[% 'EAN' | $T8 %]</th>
-    <th class="listheading">[% 'Service, assembly or part' | $T8 %]</th>
-    <th class="listheading">[% 'Obsolete' | $T8 %]</th>
+    <th>[% 'Partnumber' | $T8 %]</th>
+    <th>[% 'Description' | $T8 %]</th>
+    <th>[% 'Unit' | $T8 %]</th>
+    <th>[% 'Notes' | $T8 %]</th>
+    <th>[% 'EAN' | $T8 %]</th>
+    <th>[% 'Service, assembly or part' | $T8 %]</th>
+    <th>[% 'Obsolete' | $T8 %]</th>
   </tr>
-
-  [% SET row_odd = '1' %][% FOREACH row = ALL_PARTS %]
-  <tr class="listrow[% IF row_odd %]1[% SET row_odd = '0' %][% ELSE %]0[% SET row_odd = '1' %][% END %]">
-    <td align="right">[% HTML.escape(row.partnumber) %]</td>
-    <td align="left"> [% HTML.escape(row.description) %]</a></td>
-    <td align="right">[% HTML.escape(row.unit) %]</td>
-    <td align="right">[% HTML.escape(row.notes) %]</td>
-    <td align="right">[% HTML.escape(row.ean) %]</td>
-    <td align="right">[% IF row.assembly %] [% 'assembly' | $T8 %] [% ELSE %] [% IF row.inventory_accno_id %] [% 'part' | $T8 %] [% ELSE %] [% 'service' | $T8 %] [% END %] [% END %]</td>
-    <td>[% IF row.obsolete %][%- LxERP.t8("Obsolete") %][%- ELSE %][%- LxERP.t8("Not obsolete") %][%- END %]</td>
+</thead>
+<tbody>
+  [% SET row_odd = '1' %]
+  [% FOREACH row = ALL_PARTS %]
+  <tr>
+    <td>[% HTML.escape(row.partnumber) %]</td>
+    <td> [% HTML.escape(row.description) %]</a></td>
+    <td>[% HTML.escape(row.unit) %]</td>
+    <td>[% HTML.escape(row.notes) %]</td>
+    <td>[% HTML.escape(row.ean) %]</td>
+    <td>[% IF row.assembly %] [% 'assembly' | $T8 %] [% ELSE %] [% IF row.inventory_accno_id %] [% 'part' | $T8 %] [% ELSE %] [% 'service' | $T8 %] [% END %] [% END %]</td>
+    <td>[% IF row.obsolete %][% LxERP.t8("Obsolete") %][% ELSE %][% LxERP.t8("Not obsolete") %][% END %]</td>
   </tr>
   [% END %]
+</tbody>
 </table>
 
-<input class="submit" type="button" value="[% 'Close window' | $T8 %]" onclick="window.close()">
+<div class="buttons">
+  <input type="button" value="[% 'Close window' | $T8 %]" onclick="window.close()">
+</div>
 
 </form>